LFR-FSW - Task #1046

compilation de RTEMS avec I'option -mfix-b2bst
01/04/2017 06:27 PM - paul leroy

Status: Closed Start date: 01/04/2017
Priority: Normal Due date:

Assignee: bruno katra % Done: 50%
Category: Estimated time: 0.00 hour
Target version: Spent time: 0.10 hour
revision:

Description

Vérifier que la version de RTEMS utilisée est compilée avec I'option -mfix-b2bst et si ce n'est pas le cas, trouver comment I'activer et
recompiler.

History

#1 - 01/04/2017 06:36 PM - paul leroy
- File Capture du 2017-04-01 18-29-33.png added
- File target.cfg added

Dans la documentation RCC, on peut lire des renseignements sur l'option mfix-b2bst (cf capture jointe). Notamment:

-mfix-b2bst Enables B2BST Errata work around (present in UT699/699e/700 and GR712RC). _ FIX B2BST is predefine
d by the preprocessor. The work around is automatically activated when using -mtune=ut699 therefore this optio
n shall not be used together with mtune=ut699

On lit dans le fichier /opt/rtems-4.10/sparc-rtems/leon3/make/target.cgf (joint également)

CFLAGS = -mcpu=cypress -msoft-float -mtune=ut699 -02 -g -Wall -Wimplicit-function-declaration -Wstrict-prototy
pes -Wnested-externs

Je retrouve ces options dans les lignes de compilation qui défilent lorsque je lance make compile-drvmgr. Je comprends mal le -mcpu=cypress,
mais par contre l'option -mtune=ut699 semble impliquer que le workaround est activé automatiquement, d'aprés I'extrait de la doc RCC cité juste au
dessus.

Qu'en pensez-vous?

#2 - 01/04/2017 06:36 PM - paul leroy

- Assignee changed from paul leroy to Alexis Jeandet

#3 - 03/04/2017 12:08 AM - bruno katra

Oui en effet, ¢a parait pas mal confirmer que le drvmgr est bien compilé avec I'option. De plus et pour aller dans le méme sens, la doc dit bien que
I'option -mfix-b2bst ne devrait d'ailleurs pas étre utilisée conjointement avec le -mtune=ut699 que tu utilises.

#4 - 03/04/2017 03:54 PM - Alexis Jeandet
En relisant bien la note de Gaisler, j'ai vu qu'il fournissaient un script TCL pour vérifier si on a ou pas une des séquences d'instructions interdites.

Lien vers les infos
Script

Je vais tenter de l'intégrer dans la chaine de compilation du FSW.

#5 - 03/04/2017 04:03 PM - Alexis Jeandet
- File b2bst-fsw-3-2-0-12.log added
- % Done changed from 0 to 50

Bon d'apreés l'outil I'option n'est pas active ou moins pour une partie du code. Voir Log en PJ.
http://www.gaisler.com/index.php/information/app-tech-notes
http://www.gaisler.com/doc/antn/leon3ft-b2bst-scan.tcl

#6 - 04/04/2017 04:18 PM - paul leroy

- Assignee changed from Alexis Jeandet to paul leroy

Contacter Gaisler.

#7 - 07/04/2017 07:31 AM - paul leroy

- Assignee changed from paul leroy to bruno katra

Echange de mail avec Gaisler. La derniere version de RCC, 1.2.20b contient l'option mfix-b2bst par défaut. Recompilation avec la source du driver

grspw.c modifiée pour éviter la détection de reconnexion par le DPU lors du démarrage.
Vérification du fsw généré en utilisant le script TCL fourni par Gaisler.
Intégration du script dans la chaine de compilation du fsw grace a Alexis.

Tout semble nominale pour la révision 3.2.0.15. Je pense qu'on peut clore l'issue.

#8 - 18/04/2017 02:02 PM - bruno katra

- Status changed from New to Closed

Ok

Files

Capture du 2017-04-01 18-29-33.png 84.9 KB 01/04/2017 paul leroy
target.cfg 1.15 KB 01/04/2017 paul leroy
b2bst-fsw-3-2-0-12.log 361 KB 03/04/2017 Alexis Jeandet
